Gentoo Archives: gentoo-commits

From: Nick Sarnie <sarnex@g.o>
To: gentoo-commits@l.g.o
Subject: [gentoo-commits] repo/gentoo:master commit in: app-emulation/wine-vanilla/
Date: Sat, 24 Apr 2021 20:59:56
Message-Id: 1619297985.28d09af1e6236db78540bbfb5dcc3d6c82b5b808.sarnex@gentoo
1 commit: 28d09af1e6236db78540bbfb5dcc3d6c82b5b808
2 Author: Nick Sarnie <sarnex <AT> gentoo <DOT> org>
3 AuthorDate: Sat Apr 24 20:58:43 2021 +0000
4 Commit: Nick Sarnie <sarnex <AT> gentoo <DOT> org>
5 CommitDate: Sat Apr 24 20:59:45 2021 +0000
6 URL: https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=28d09af1
7
8 app-emulation/wine-vanilla: Sync with ::wine
9
10 Package-Manager: Portage-3.0.18, Repoman-3.0.3
11 Signed-off-by: Nick Sarnie <sarnex <AT> gentoo.org>
12
13 app-emulation/wine-vanilla/Manifest | 1 +
14 app-emulation/wine-vanilla/wine-vanilla-6.7.ebuild | 577 +++++++++++++++++++++
15 2 files changed, 578 insertions(+)
16
17 diff --git a/app-emulation/wine-vanilla/Manifest b/app-emulation/wine-vanilla/Manifest
18 index f3e3bae6fcd..aa12d3e76b1 100644
19 --- a/app-emulation/wine-vanilla/Manifest
20 +++ b/app-emulation/wine-vanilla/Manifest
21 @@ -5,3 +5,4 @@ DIST wine-6.3.tar.xz 24301496 BLAKE2B d36e46e369abc619d351dd3209c0c86c5e5924509f
22 DIST wine-6.4.tar.xz 24340220 BLAKE2B b09ea9237b71856184a03e64ef8cf7aa30591ebd6534a550e9365ea9ab773d81283520ca6b0efc8aa69063cdeae8da35fc22e08a40c73c6268db4d57b0442ad2 SHA512 f190e1b97defb4620e33d1a4e2afffd475f6b3998153c67c6d06840b4f3b93a50f88c6844de15e7f54ca712330f6fea857310861a78b961feb7f64a4869f3fe1
23 DIST wine-6.5.tar.xz 24375196 BLAKE2B c30f606d268bf39f9424dd2e65f98f75b3538c82df6a931ea4955040a625ff07a2272f7d83f4343f8997ac2660a934528279ff31555ef062c81487e897c429f9 SHA512 11f9d2bb515c63429d397b97ecc1f13d0dbb717780d674229b851b819d707e0fd6fbf8bbae9a41dbf7b2ceb3729c4f5643d1ec5e414d6694d192072081f96fe4
24 DIST wine-6.6.tar.xz 24400568 BLAKE2B 37ec581686a2145a84cd40a1c29c313cf253f96c86fd16fac0402afb02aa15687b86e2de850b86c9a132b8898ab93b639f431711f3c6220a566537768612f97a SHA512 a5caabc5ff91a830fbdcd25a85ee32b6df98315325a929a3124521cd10cc873e5a585359b03eb0293bb2474e39a179cbe179c0611acda6a228861e06068c091e
25 +DIST wine-6.7.tar.xz 24449368 BLAKE2B 002bd6e74205217d4517c8697ddb212d8bcb8ba66ac1594996e24e2d5e771119e73e65a0b42608133ebaab699a31cd6567a0ab954e8d4e1f94492ebb929d0ffb SHA512 42920921eaff5a483859fba2b9e866c6afad25427d030f971efe2136f9619b675d5eb1ddfffd54bba8caa172c3e91eb347d673cb16f45560f0ab40a184a34758
26
27 diff --git a/app-emulation/wine-vanilla/wine-vanilla-6.7.ebuild b/app-emulation/wine-vanilla/wine-vanilla-6.7.ebuild
28 new file mode 100644
29 index 00000000000..32fbb98391a
30 --- /dev/null
31 +++ b/app-emulation/wine-vanilla/wine-vanilla-6.7.ebuild
32 @@ -0,0 +1,577 @@
33 +# Copyright 1999-2021 Gentoo Authors
34 +# Distributed under the terms of the GNU General Public License v2
35 +
36 +EAPI=6
37 +
38 +PLOCALES="ar ast bg ca cs da de el en en_US eo es fa fi fr he hi hr hu it ja ko lt ml nb_NO nl or pa pl pt_BR pt_PT rm ro ru si sk sl sr_RS@cyrillic sr_RS@latin sv ta te th tr uk wa zh_CN zh_TW"
39 +PLOCALE_BACKUP="en"
40 +
41 +inherit autotools eapi7-ver estack eutils flag-o-matic gnome2-utils l10n multilib multilib-minimal pax-utils toolchain-funcs virtualx xdg-utils
42 +
43 +MY_PN="${PN%%-*}"
44 +MY_P="${MY_PN}-${PV}"
45 +
46 +if [[ ${PV} == "9999" ]] ; then
47 + EGIT_REPO_URI="https://source.winehq.org/git/wine.git"
48 + EGIT_BRANCH="master"
49 + inherit git-r3
50 + SRC_URI=""
51 + #KEYWORDS=""
52 +else
53 + MAJOR_V=$(ver_cut 1)
54 + SRC_URI="https://dl.winehq.org/wine/source/${MAJOR_V}.x/${MY_P}.tar.xz"
55 + KEYWORDS="-* ~amd64 ~x86"
56 +fi
57 +S="${WORKDIR}/${MY_P}"
58 +
59 +GWP_V="20200523"
60 +PATCHDIR="${WORKDIR}/gentoo-wine-patches"
61 +
62 +DESCRIPTION="Free implementation of Windows(tm) on Unix, without external patchsets"
63 +HOMEPAGE="https://www.winehq.org/"
64 +SRC_URI="${SRC_URI}
65 + https://dev.gentoo.org/~sarnex/distfiles/wine/gentoo-wine-patches-${GWP_V}.tar.xz
66 +"
67 +
68 +LICENSE="LGPL-2.1"
69 +SLOT="${PV}"
70 +IUSE="+abi_x86_32 +abi_x86_64 +alsa capi cups custom-cflags dos elibc_glibc +faudio +fontconfig +gecko gphoto2 gsm gssapi gstreamer +jpeg kerberos kernel_FreeBSD +lcms ldap mingw +mono mp3 netapi nls odbc openal opencl +opengl osmesa oss +perl pcap +png prelink pulseaudio +realtime +run-exes samba scanner sdl selinux +ssl test +threads +truetype udev +udisks +unwind usb v4l vkd3d vulkan +X +xcomposite xinerama +xml"
71 +REQUIRED_USE="|| ( abi_x86_32 abi_x86_64 )
72 + X? ( truetype )
73 + elibc_glibc? ( threads )
74 + osmesa? ( opengl )
75 + test? ( abi_x86_32 )
76 + vkd3d? ( vulkan )" # osmesa-opengl #286560 # X-truetype #551124
77 +
78 +# FIXME: the test suite is unsuitable for us; many tests require net access
79 +# or fail due to Xvfb's opengl limitations.
80 +RESTRICT="test"
81 +
82 +COMMON_DEPEND="
83 + X? (
84 + x11-libs/libXcursor[${MULTILIB_USEDEP}]
85 + x11-libs/libXext[${MULTILIB_USEDEP}]
86 + x11-libs/libXfixes[${MULTILIB_USEDEP}]
87 + x11-libs/libXrandr[${MULTILIB_USEDEP}]
88 + x11-libs/libXi[${MULTILIB_USEDEP}]
89 + x11-libs/libXxf86vm[${MULTILIB_USEDEP}]
90 + )
91 + alsa? ( media-libs/alsa-lib[${MULTILIB_USEDEP}] )
92 + capi? ( net-libs/libcapi[${MULTILIB_USEDEP}] )
93 + cups? ( net-print/cups:=[${MULTILIB_USEDEP}] )
94 + faudio? ( app-emulation/faudio:=[${MULTILIB_USEDEP}] )
95 + fontconfig? ( media-libs/fontconfig:=[${MULTILIB_USEDEP}] )
96 + gphoto2? ( media-libs/libgphoto2:=[${MULTILIB_USEDEP}] )
97 + gsm? ( media-sound/gsm:=[${MULTILIB_USEDEP}] )
98 + gssapi? ( virtual/krb5[${MULTILIB_USEDEP}] )
99 + gstreamer? (
100 + media-libs/gstreamer:1.0[${MULTILIB_USEDEP}]
101 + media-plugins/gst-plugins-meta:1.0[${MULTILIB_USEDEP}]
102 + )
103 + jpeg? ( virtual/jpeg:0=[${MULTILIB_USEDEP}] )
104 + kerberos? ( virtual/krb5[${MULTILIB_USEDEP}] )
105 + lcms? ( media-libs/lcms:2=[${MULTILIB_USEDEP}] )
106 + ldap? ( net-nds/openldap:=[${MULTILIB_USEDEP}] )
107 + mp3? ( >=media-sound/mpg123-1.5.0[${MULTILIB_USEDEP}] )
108 + netapi? ( net-fs/samba[netapi(+),${MULTILIB_USEDEP}] )
109 + nls? ( sys-devel/gettext[${MULTILIB_USEDEP}] )
110 + odbc? ( dev-db/unixODBC:=[${MULTILIB_USEDEP}] )
111 + openal? ( media-libs/openal:=[${MULTILIB_USEDEP}] )
112 + opencl? ( virtual/opencl[${MULTILIB_USEDEP}] )
113 + opengl? (
114 + virtual/glu[${MULTILIB_USEDEP}]
115 + virtual/opengl[${MULTILIB_USEDEP}]
116 + )
117 + osmesa? ( >=media-libs/mesa-13[osmesa,${MULTILIB_USEDEP}] )
118 + pcap? ( net-libs/libpcap[${MULTILIB_USEDEP}] )
119 + png? ( media-libs/libpng:0=[${MULTILIB_USEDEP}] )
120 + pulseaudio? ( media-sound/pulseaudio[${MULTILIB_USEDEP}] )
121 + scanner? ( media-gfx/sane-backends:=[${MULTILIB_USEDEP}] )
122 + sdl? ( media-libs/libsdl2:=[haptic,joystick,${MULTILIB_USEDEP}] )
123 + ssl? ( net-libs/gnutls:=[${MULTILIB_USEDEP}] )
124 + truetype? ( >=media-libs/freetype-2.0.0[${MULTILIB_USEDEP}] )
125 + udev? ( virtual/libudev:=[${MULTILIB_USEDEP}] )
126 + udisks? ( sys-apps/dbus[${MULTILIB_USEDEP}] )
127 + unwind? ( sys-libs/libunwind[${MULTILIB_USEDEP}] )
128 + usb? ( virtual/libusb:1[${MULTILIB_USEDEP}] )
129 + v4l? ( media-libs/libv4l[${MULTILIB_USEDEP}] )
130 + vkd3d? ( >=app-emulation/vkd3d-1.2[${MULTILIB_USEDEP}] )
131 + vulkan? ( media-libs/vulkan-loader[${MULTILIB_USEDEP}] )
132 + xcomposite? ( x11-libs/libXcomposite[${MULTILIB_USEDEP}] )
133 + xinerama? ( x11-libs/libXinerama[${MULTILIB_USEDEP}] )
134 + xml? (
135 + dev-libs/libxml2[${MULTILIB_USEDEP}]
136 + dev-libs/libxslt[${MULTILIB_USEDEP}]
137 + )"
138 +
139 +RDEPEND="${COMMON_DEPEND}
140 + app-emulation/wine-desktop-common
141 + >app-eselect/eselect-wine-0.3
142 + !app-emulation/wine:0
143 + dos? ( >=games-emulation/dosbox-0.74_p20160629 )
144 + gecko? ( app-emulation/wine-gecko:2.47.2[abi_x86_32?,abi_x86_64?] )
145 + mono? ( app-emulation/wine-mono:6.1.1 )
146 + perl? (
147 + dev-lang/perl
148 + dev-perl/XML-Simple
149 + )
150 + pulseaudio? (
151 + realtime? ( sys-auth/rtkit )
152 + )
153 + samba? ( >=net-fs/samba-3.0.25[winbind] )
154 + selinux? ( sec-policy/selinux-wine )
155 + udisks? ( sys-fs/udisks:2 )"
156 +
157 +# tools/make_requests requires perl
158 +DEPEND="${COMMON_DEPEND}
159 + sys-devel/flex
160 + >=sys-kernel/linux-headers-2.6
161 + virtual/pkgconfig
162 + virtual/yacc
163 + X? ( x11-base/xorg-proto )
164 + prelink? ( sys-devel/prelink )
165 + xinerama? ( x11-base/xorg-proto )"
166 +
167 +# These use a non-standard "Wine" category, which is provided by
168 +# /etc/xdg/applications-merged/wine.menu
169 +QA_DESKTOP_FILE="usr/share/applications/wine-browsedrive.desktop
170 +usr/share/applications/wine-notepad.desktop
171 +usr/share/applications/wine-uninstaller.desktop
172 +usr/share/applications/wine-winecfg.desktop"
173 +
174 +PATCHES=(
175 + "${PATCHDIR}/patches/${MY_PN}-5.0-winegcc.patch" #260726
176 + "${PATCHDIR}/patches/${MY_PN}-4.7-multilib-portage.patch" #395615
177 + "${PATCHDIR}/patches/${MY_PN}-2.0-multislot-apploader.patch" #310611
178 + "${PATCHDIR}/patches/${MY_PN}-5.9-Revert-makedep-Install-also-generated-typelib-for-in.patch"
179 +)
180 +PATCHES_BIN=()
181 +
182 +# https://bugs.gentoo.org/show_bug.cgi?id=635222
183 +if [[ ${#PATCHES_BIN[@]} -ge 1 ]] || [[ ${PV} == 9999 ]]; then
184 + DEPEND+=" dev-util/patchbin"
185 +fi
186 +
187 +wine_compiler_check() {
188 + # GCC-specific bugs
189 + if tc-is-gcc; then
190 + # bug #549768
191 + if use abi_x86_64 && [[ $(gcc-major-version) = 5 && $(gcc-minor-version) -le 2 ]]; then
192 + ebegin "Checking for gcc-5 ms_abi compiler bug"
193 + $(tc-getCC) -O2 "${PATCHDIR}/files/pr66838.c" -o "${T}"/pr66838 || die
194 + # Run in subshell to prevent "Aborted" message
195 + ( "${T}"/pr66838 || false ) >/dev/null 2>&1
196 + if ! eend $?; then
197 + eerror "64-bit wine cannot be built with gcc-5.1 or initial patchset of 5.2.0"
198 + eerror "due to compiler bugs; please re-emerge the latest gcc-5.2.x ebuild,"
199 + eerror "or use gcc-config to select a different compiler version."
200 + eerror "See https://bugs.gentoo.org/549768"
201 + eerror
202 + return 1
203 + fi
204 + fi
205 + # bug #574044
206 + if use abi_x86_64 && [[ $(gcc-major-version) = 5 && $(gcc-minor-version) = 3 ]]; then
207 + ebegin "Checking for gcc-5-3 stack realignment compiler bug"
208 + # Compile in subshell to prevent "Aborted" message
209 + ( $(tc-getCC) -O2 -mincoming-stack-boundary=3 "${PATCHDIR}/files/pr69140.c" -o "${T}"/pr69140 ) >/dev/null 2>&1
210 + if ! eend $?; then
211 + eerror "Wine cannot be built with this version of gcc-5.3"
212 + eerror "due to compiler bugs; please re-emerge the latest gcc-5.3.x ebuild,"
213 + eerror "or use gcc-config to select a different compiler version."
214 + eerror "See https://bugs.gentoo.org/574044"
215 + eerror
216 + return 1
217 + fi
218 + fi
219 + fi
220 +
221 + # Ensure compiler support
222 + if use abi_x86_64; then
223 + ebegin "Checking for 64-bit compiler with builtin_ms_va_list support"
224 + # Compile in subshell to prevent "Aborted" message
225 + ( $(tc-getCC) -O2 "${PATCHDIR}/files/builtin_ms_va_list.c" -o "${T}"/builtin_ms_va_list >/dev/null 2>&1)
226 + if ! eend $?; then
227 + eerror "This version of $(tc-getCC) does not support builtin_ms_va_list, can't enable 64-bit wine"
228 + eerror
229 + eerror "You need gcc-4.4+ or clang 3.8+ to build 64-bit wine"
230 + eerror
231 + return 1
232 + fi
233 + fi
234 +}
235 +
236 +wine_build_environment_check() {
237 + [[ ${MERGE_TYPE} = "binary" ]] && return 0
238 +
239 + if use abi_x86_64; then
240 + if tc-is-gcc && [[ $(gcc-major-version) -lt 4 || ( $(gcc-major-version) -eq 4 && $(gcc-minor-version) -lt 4 ) ]]; then
241 + eerror "You need gcc-4.4+ to compile 64-bit wine"
242 + die
243 + elif tc-is-clang && [[ $(clang-major-version) -lt 3 || ( $(clang-major-version) -eq 3 && $(clang-minor-version) -lt 8 ) ]]; then
244 + eerror "You need clang-3.8+ to compile 64-bit wine"
245 + die
246 + fi
247 + fi
248 + if tc-is-gcc && [[ $(gcc-major-version) -eq 5 && $(gcc-minor-version) -le 3 ]]; then
249 + ewarn "GCC-5.0-5.3 suffered from compiler bugs and are no longer supported by"
250 + ewarn "Gentoo's Toolchain Team. If your ebuild fails the compiler checks in"
251 + ewarn "the configure phase, either update your compiler or switch to <5.0 || >=5.4"
252 + fi
253 + if tc-is-gcc && [[ $(gcc-major-version) -eq 5 && $(gcc-minor-version) -eq 4 ]]; then
254 + if has "-march=i686" ${CFLAGS} && ! has "-mtune=generic" ${CFLAGS}; then
255 + ewarn "Compilation can hang with CFLAGS=\"-march=i686\". You can temporarily work"
256 + ewarn "around this by adding \"-mtune=generic\" to your CFLAGS for wine."
257 + ewarn "See package.env in man 5 portage for more information on how to do this."
258 + ewarn "See https://bugs.gentoo.org/show_bug.cgi?id=613128 for more details"
259 + fi
260 + fi
261 +
262 + if use abi_x86_32 && use opencl && [[ "$(eselect opencl show 2> /dev/null)" == "intel" ]]; then
263 + eerror "You cannot build wine with USE=opencl because intel-ocl-sdk is 64-bit only."
264 + eerror "See https://bugs.gentoo.org/487864 for more details."
265 + eerror
266 + return 1
267 + fi
268 +}
269 +
270 +wine_env_vcs_vars() {
271 + local pn_live_var="${PN//[-+]/_}_LIVE_COMMIT"
272 + local pn_live_val="${pn_live_var}"
273 + eval pn_live_val='$'${pn_live_val}
274 + if [[ ! -z ${EGIT_COMMIT} ]]; then
275 + eerror "Commits must now be specified using the environmental variables"
276 + eerror "EGIT_OVERRIDE_COMMIT_WINE"
277 + eerror
278 + return 1
279 + fi
280 +}
281 +
282 +pkg_pretend() {
283 + wine_build_environment_check || die
284 +
285 + # Verify OSS support
286 + if use oss && ! use kernel_FreeBSD; then
287 + if ! has_version ">=media-sound/oss-4"; then
288 + eerror "You cannot build wine with USE=oss without having support from a"
289 + eerror "FreeBSD kernel or >=media-sound/oss-4 (only available through external repos)"
290 + eerror
291 + die
292 + fi
293 + fi
294 +
295 + if use mingw && use abi_x86_32 && ! has_version "cross-i686-w64-mingw32/gcc"; then
296 + eerror
297 + eerror "USE=\"mingw\" is currently experimental, and requires the"
298 + eerror "'cross-i686-w64-mingw32' compiler and its runtime for 32-bit builds."
299 + eerror
300 + eerror "These can be installed by using 'sys-devel/crossdev':"
301 + eerror
302 + eerror "crossdev --target i686-w64-mingw32"
303 + eerror
304 + eerror "For more information on setting up MinGW, see: https://wiki.gentoo.org/wiki/Mingw"
305 + eerror
306 + die "MinGW build was enabled, but no compiler to support it was found."
307 + fi
308 +
309 + if use mingw && use abi_x86_64 && ! has_version "cross-x86_64-w64-mingw32/gcc"; then
310 + eerror
311 + eerror "USE=\"mingw\" is currently experimental, and requires the"
312 + eerror "'cross-x86_64-w64-mingw32' compiler and its runtime for 64-bit builds."
313 + eerror
314 + eerror "These can be installed by using 'sys-devel/crossdev':"
315 + eerror
316 + eerror "crossdev --target x86_64-w64-mingw32"
317 + eerror
318 + eerror "For more information on setting up MinGW, see: https://wiki.gentoo.org/wiki/Mingw"
319 + eerror
320 + die "MinGW build was enabled, but no compiler to support it was found."
321 + fi
322 +}
323 +
324 +pkg_setup() {
325 + wine_build_environment_check || die
326 + wine_env_vcs_vars || die
327 +
328 + WINE_VARIANT="${PN#wine}-${PV}"
329 + WINE_VARIANT="${WINE_VARIANT#-}"
330 +
331 + MY_PREFIX="${EPREFIX}/usr/lib/wine-${WINE_VARIANT}"
332 + MY_DATAROOTDIR="${EPREFIX}/usr/share/wine-${WINE_VARIANT}"
333 + MY_DATADIR="${MY_DATAROOTDIR}"
334 + MY_DOCDIR="${EPREFIX}/usr/share/doc/${PF}"
335 + MY_INCLUDEDIR="${EPREFIX}/usr/include/wine-${WINE_VARIANT}"
336 + MY_LIBEXECDIR="${EPREFIX}/usr/libexec/wine-${WINE_VARIANT}"
337 + MY_LOCALSTATEDIR="${EPREFIX}/var/wine-${WINE_VARIANT}"
338 + MY_MANDIR="${MY_DATADIR}/man"
339 +}
340 +
341 +src_unpack() {
342 + if [[ ${PV} == "9999" ]] ; then
343 + EGIT_CHECKOUT_DIR="${S}" git-r3_src_unpack
344 + fi
345 +
346 + default
347 +
348 + l10n_find_plocales_changes "${S}/po" "" ".po"
349 +}
350 +
351 +src_prepare() {
352 +
353 + eapply_bin(){
354 + local patch
355 + for patch in ${PATCHES_BIN[@]}; do
356 + patchbin --nogit < "${patch}" || die
357 + done
358 + }
359 +
360 + local md5="$(md5sum server/protocol.def)"
361 +
362 + default
363 + eapply_bin
364 + eautoreconf
365 +
366 + # Modification of the server protocol requires regenerating the server requests
367 + if [[ "$(md5sum server/protocol.def)" != "${md5}" ]]; then
368 + einfo "server/protocol.def was patched; running tools/make_requests"
369 + tools/make_requests || die #432348
370 + fi
371 + sed -i '/^UPDATE_DESKTOP_DATABASE/s:=.*:=true:' tools/Makefile.in || die
372 + if ! use run-exes; then
373 + sed -i '/^MimeType/d' loader/wine.desktop || die #117785
374 + fi
375 +
376 + # Edit wine.desktop to work for specific variant
377 + sed -e "/^Exec=/s/wine /wine-${WINE_VARIANT} /" -i loader/wine.desktop || die
378 +
379 + # hi-res default icon, #472990, https://bugs.winehq.org/show_bug.cgi?id=24652
380 + cp "${PATCHDIR}/files/oic_winlogo.ico" dlls/user32/resources/ || die
381 +
382 + l10n_get_locales > po/LINGUAS || die # otherwise wine doesn't respect LINGUAS
383 +
384 + # Fix manpage generation for locales #469418 and abi_x86_64 #617864
385 +
386 + # Duplicate manpages input files for wine64
387 + local f
388 + for f in loader/*.man.in; do
389 + cp ${f} ${f/wine/wine64} || die
390 + done
391 + # Add wine64 manpages to Makefile
392 + if use abi_x86_64; then
393 + sed -i "/wine.man.in/i \
394 + \\\twine64.man.in \\\\" loader/Makefile.in || die
395 + sed -i -E 's/(.*wine)(.*\.UTF-8\.man\.in.*)/&\
396 +\164\2/' loader/Makefile.in || die
397 + fi
398 +
399 + rm_man_file(){
400 + local file="${1}"
401 + loc=${2}
402 + sed -i "/${loc}\.UTF-8\.man\.in/d" "${file}" || die
403 + }
404 +
405 + while read f; do
406 + l10n_for_each_disabled_locale_do rm_man_file "${f}"
407 + done < <(find -name "Makefile.in" -exec grep -q "UTF-8.man.in" "{}" \; -print)
408 +}
409 +
410 +src_configure() {
411 + wine_compiler_check || die
412 +
413 + export LDCONFIG=/bin/true
414 + use custom-cflags || strip-flags
415 + if use mingw; then
416 + export CROSSCFLAGS="${CFLAGS}"
417 + fi
418 +
419 + multilib-minimal_src_configure
420 +}
421 +
422 +multilib_src_configure() {
423 + local myconf=(
424 + --prefix="${MY_PREFIX}"
425 + --datarootdir="${MY_DATAROOTDIR}"
426 + --datadir="${MY_DATADIR}"
427 + --docdir="${MY_DOCDIR}"
428 + --includedir="${MY_INCLUDEDIR}"
429 + --libdir="${EPREFIX}/usr/$(get_libdir)/wine-${WINE_VARIANT}"
430 + --libexecdir="${MY_LIBEXECDIR}"
431 + --localstatedir="${MY_LOCALSTATEDIR}"
432 + --mandir="${MY_MANDIR}"
433 + --sysconfdir="${EPREFIX}/etc/wine"
434 + $(use_with alsa)
435 + $(use_with capi)
436 + $(use_with lcms cms)
437 + $(use_with cups)
438 + $(use_with udisks dbus)
439 + $(use_with faudio)
440 + $(use_with fontconfig)
441 + $(use_with ssl gnutls)
442 + $(use_enable gecko mshtml)
443 + $(use_with gphoto2 gphoto)
444 + $(use_with gsm)
445 + $(use_with gssapi)
446 + $(use_with gstreamer)
447 + --without-hal
448 + $(use_with jpeg)
449 + $(use_with kerberos krb5)
450 + $(use_with ldap)
451 + # TODO: Will bug 685172 still need special handling?
452 + $(use_with mingw)
453 + $(use_enable mono mscoree)
454 + $(use_with mp3 mpg123)
455 + $(use_with netapi)
456 + $(use_with nls gettext)
457 + $(use_with openal)
458 + $(use_with opencl)
459 + $(use_with opengl)
460 + $(use_with osmesa)
461 + $(use_with oss)
462 + $(use_with pcap)
463 + $(use_with png)
464 + $(use_with pulseaudio pulse)
465 + $(use_with threads pthread)
466 + $(use_with scanner sane)
467 + $(use_with sdl)
468 + $(use_enable test tests)
469 + $(use_with truetype freetype)
470 + $(use_with udev)
471 + $(use_with unwind)
472 + $(use_with usb)
473 + $(use_with v4l v4l2)
474 + $(use_with vkd3d)
475 + $(use_with vulkan)
476 + $(use_with X x)
477 + $(use_with X xfixes)
478 + $(use_with xcomposite)
479 + $(use_with xinerama)
480 + $(use_with xml)
481 + $(use_with xml xslt)
482 + )
483 +
484 + local PKG_CONFIG
485 + # Avoid crossdev's i686-pc-linux-gnu-pkg-config if building wine32 on amd64; #472038
486 + tc-export PKG_CONFIG
487 +
488 + if use amd64; then
489 + if [[ ${ABI} == amd64 ]]; then
490 + myconf+=( --enable-win64 )
491 + else
492 + myconf+=( --disable-win64 )
493 + fi
494 +
495 + # Note: using --with-wine64 results in problems with multilib.eclass
496 + # CC/LD hackery. We're using separate tools instead.
497 + fi
498 +
499 + ECONF_SOURCE=${S} \
500 + econf "${myconf[@]}"
501 + emake depend
502 +}
503 +
504 +multilib_src_test() {
505 + # FIXME: win32-only; wine64 tests fail with "could not find the Wine loader"
506 + if [[ ${ABI} == x86 ]]; then
507 + if [[ $(id -u) == 0 ]]; then
508 + ewarn "Skipping tests since they cannot be run under the root user."
509 + ewarn "To run the test ${MY_PN} suite, add userpriv to FEATURES in make.conf"
510 + return
511 + fi
512 +
513 + WINEPREFIX="${T}/.wine-${ABI}" \
514 + virtx emake test
515 + fi
516 +}
517 +
518 +multilib_src_install_all() {
519 + local DOCS=( ANNOUNCE AUTHORS README )
520 + add_locale_docs() {
521 + local locale_doc="documentation/README.$1"
522 + [[ ! -e ${locale_doc} ]] || DOCS+=( ${locale_doc} )
523 + }
524 + l10n_for_each_locale_do add_locale_docs
525 +
526 + einstalldocs
527 + prune_libtool_files --all
528 +
529 + if ! use perl ; then # winedump calls function_grep.pl, and winemaker is a perl script
530 + rm "${D%/}${MY_PREFIX}"/bin/{wine{dump,maker},function_grep.pl} \
531 + "${D%/}${MY_MANDIR}"/man1/wine{dump,maker}.1 || die
532 + fi
533 +
534 + # Remove wineconsole if neither backend is installed #551124
535 + if ! use X; then
536 + rm "${D%/}${MY_PREFIX}"/bin/wineconsole* || die
537 + rm "${D%/}${MY_MANDIR}"/man1/wineconsole* || die
538 +
539 + if ! use mingw; then
540 + rm_wineconsole() {
541 + rm "${D%/}/usr/$(get_libdir)/wine-${WINE_VARIANT}"/wine/{,fakedlls/}wineconsole.exe* || die
542 + }
543 + else
544 + rm_wineconsole() {
545 + rm "${D%/}/usr/$(get_libdir)/wine-${WINE_VARIANT}"/wine/wineconsole.exe* || die
546 + }
547 + fi
548 +
549 + multilib_foreach_abi rm_wineconsole
550 + fi
551 +
552 + use abi_x86_32 && pax-mark psmr "${D%/}${MY_PREFIX}"/bin/wine{,-preloader} #255055
553 + use abi_x86_64 && pax-mark psmr "${D%/}${MY_PREFIX}"/bin/wine64{,-preloader}
554 +
555 + # Avoid double prefix from dosym and make_wrapper
556 + MY_PREFIX=${MY_PREFIX#${EPREFIX}}
557 +
558 + if use abi_x86_64 && ! use abi_x86_32; then
559 + dosym wine64 "${MY_PREFIX}"/bin/wine # 404331
560 + dosym wine64-preloader "${MY_PREFIX}"/bin/wine-preloader
561 + fi
562 +
563 + # Failglob for binloops, shouldn't be necessary, but including to stay safe
564 + eshopts_push -s failglob #615218
565 + # Make wrappers for binaries for handling multiple variants
566 + # Note: wrappers instead of symlinks because some are shell which use basename
567 + local b
568 + for b in "${ED%/}${MY_PREFIX}"/bin/*; do
569 + make_wrapper "${b##*/}-${WINE_VARIANT}" "${MY_PREFIX}/bin/${b##*/}"
570 + done
571 + eshopts_pop
572 +}
573 +
574 +pkg_postinst() {
575 + eselect wine register ${P}
576 + if [[ ${PN} == "wine-vanilla" ]]; then
577 + eselect wine register --vanilla ${P} || die
578 + fi
579 +
580 + eselect wine update --all --if-unset || die
581 +
582 + xdg_desktop_database_update
583 +
584 + if ! use gecko; then
585 + ewarn "Without Wine Gecko, wine prefixes will not have a default"
586 + ewarn "implementation of iexplore. Many older windows applications"
587 + ewarn "rely upon the existence of an iexplore implementation, so"
588 + ewarn "you will likely need to install an external one, like via winetricks"
589 + fi
590 + if ! use mono; then
591 + ewarn "Without Wine Mono, wine prefixes will not have a default"
592 + ewarn "implementation of .NET. Many windows applications rely upon"
593 + ewarn "the existence of a .NET implementation, so you will likely need"
594 + ewarn "to install an external one, like via winetricks"
595 + fi
596 +}
597 +
598 +pkg_prerm() {
599 + eselect wine deregister ${P}
600 + if [[ ${PN} == "wine-vanilla" ]]; then
601 + eselect wine deregister --vanilla ${P} || die
602 + fi
603 +
604 + eselect wine update --all --if-unset || die
605 +}
606 +
607 +pkg_postrm() {
608 + xdg_desktop_database_update
609 +}